package permission

import (
	"context"
	"sghgogs.com/micro/auth-service/domain/service"
	pb "sghgogs.com/micro/auth-service/proto"
)

type Permission struct {
	Service service.IService
}

func (svc *Permission) GetAdminPermissionList(ctx context.Context, query *pb.GetAdminPermissionListRequest, rsp *pb.GetAdminPermissionListResponse) error {
	list, count, err := svc.Service.GetAdminPermissionList(query)
	if err != nil {
		return err
	} else {
		rsp.Items = list
		rsp.TotalCount = count
	}
	return nil
}
func (svc *Permission) GetAdminPermission(ctx context.Context, query *pb.GetAdminPermissionRequest, rsp *pb.GetAdminPermissionResponse) error {
	if permission, err := svc.Service.GetAdminPermission(query); err != nil {
		return err
	} else {
		rsp.Data = &permission
		return nil
	}
}

func (svc *Permission) CreateAdminPermission(ctx context.Context, query *pb.CreateAdminPermissionRequest, rsp *pb.CreateAdminPermissionResponse) error {
	err := svc.Service.CreateAdminPermission(ctx, query)
	if err != nil {
		return err
	}
	return nil
}

func (svc *Permission) UpdateAdminPermission(ctx context.Context, query *pb.UpdateAdminPermissionRequest, rsp *pb.UpdateAdminPermissionResponse) error {
	err := svc.Service.UpdateAdminPermission(ctx, query)
	if err != nil {
		return err
	}
	return nil
}

func (svc *Permission) DeleteAdminPermission(ctx context.Context, query *pb.DeleteAdminPermissionRequest, rsp *pb.DeleteAdminPermissionResponse) error {
	err := svc.Service.DeleteAdminPermission(query)
	if err != nil {
		return err
	}
	return nil
}

func (svc *Permission) ToggleAdminPermission(ctx context.Context, query *pb.ToggleAdminPermissionRequest, rsp *pb.ToggleAdminPermissionResponse) error {
	err := svc.Service.ToggleAdminPermission(query)
	if err != nil {
		return err
	}
	return nil
}
