package team

import (
	"context"
	"sghgogs.com/micro/auth-service/domain/service"
	pb "sghgogs.com/micro/auth-service/proto"
)

type Team struct {
	Service service.IService
}

func (svc *Team) GetTeamList(ctx context.Context, query *pb.GetTeamListRequest, rsp *pb.GetTeamListResponse) error {
	list, i, err := svc.Service.GetTeamList(query)
	if err != nil {
		return err
	}
	rsp.TotalCount = i
	rsp.Items = list
	return nil
}

func (svc *Team) GetAllTeams(ctx context.Context, query *pb.GetAllTeamsRequest, rsp *pb.GetAllTeamsResponse) error {
	list, err := svc.Service.GetAllTeams()
	if err != nil {
		return err
	}
	rsp.Items = list
	return nil
}

// GetAllTeams

func (svc *Team) GetTeam(ctx context.Context, query *pb.GetTeamRequest, rsp *pb.GetTeamResponse) error {
	team, err := svc.Service.GetTeam(query)
	if err != nil {
		return err
	}
	rsp.Data = team
	return nil
}

func (svc *Team) CreateTeam(ctx context.Context, team *pb.Team, rsp *pb.CreateTeamResponse) error {
	if err := svc.Service.CreateTeam(ctx, team); err != nil {
		return err
	}
	return nil
}

func (svc *Team) ToggleTeam(ctx context.Context, query *pb.ToggleTeamRequest, rsp *pb.ToggleTeamResponse) error {
	if err := svc.Service.ToggleTeam(ctx, query); err != nil {
		return err
	}
	return nil
}

func (svc *Team) DeleteTeam(ctx context.Context, query *pb.DeleteTeamRequest, rsp *pb.DeleteTeamResponse) error {
	if err := svc.Service.DeleteTeam(ctx, query); err != nil {
		return err
	}
	return nil
}

func (svc *Team) UpdateTeam(ctx context.Context, update *pb.UpdateTeamRequest, rsp *pb.UpdateTeamResponse) error {
	if err := svc.Service.UpdateTeam(ctx, update); err != nil {
		return err
	}
	return nil
}
