// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/team_service.proto

package authorization_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for TeamService service

func NewTeamServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for TeamService service

type TeamService interface {
	GetTeamList(ctx context.Context, in *GetTeamListRequest, opts ...client.CallOption) (*GetTeamListResponse, error)
	GetAllTeams(ctx context.Context, in *GetAllTeamsRequest, opts ...client.CallOption) (*GetAllTeamsResponse, error)
	GetTeam(ctx context.Context, in *GetTeamRequest, opts ...client.CallOption) (*GetTeamResponse, error)
	CreateTeam(ctx context.Context, in *Team, opts ...client.CallOption) (*CreateTeamResponse, error)
	ToggleTeam(ctx context.Context, in *ToggleTeamRequest, opts ...client.CallOption) (*ToggleTeamResponse, error)
	DeleteTeam(ctx context.Context, in *DeleteTeamRequest, opts ...client.CallOption) (*DeleteTeamResponse, error)
	UpdateTeam(ctx context.Context, in *UpdateTeamRequest, opts ...client.CallOption) (*UpdateTeamResponse, error)
}

type teamService struct {
	c    client.Client
	name string
}

func NewTeamService(name string, c client.Client) TeamService {
	return &teamService{
		c:    c,
		name: name,
	}
}

func (c *teamService) GetTeamList(ctx context.Context, in *GetTeamListRequest, opts ...client.CallOption) (*GetTeamListResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.GetTeamList", in)
	out := new(GetTeamListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) GetAllTeams(ctx context.Context, in *GetAllTeamsRequest, opts ...client.CallOption) (*GetAllTeamsResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.GetAllTeams", in)
	out := new(GetAllTeamsResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) GetTeam(ctx context.Context, in *GetTeamRequest, opts ...client.CallOption) (*GetTeamResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.GetTeam", in)
	out := new(GetTeamResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) CreateTeam(ctx context.Context, in *Team, opts ...client.CallOption) (*CreateTeamResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.CreateTeam", in)
	out := new(CreateTeamResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) ToggleTeam(ctx context.Context, in *ToggleTeamRequest, opts ...client.CallOption) (*ToggleTeamResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.ToggleTeam", in)
	out := new(ToggleTeamResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) DeleteTeam(ctx context.Context, in *DeleteTeamRequest, opts ...client.CallOption) (*DeleteTeamResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.DeleteTeam", in)
	out := new(DeleteTeamResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *teamService) UpdateTeam(ctx context.Context, in *UpdateTeamRequest, opts ...client.CallOption) (*UpdateTeamResponse, error) {
	req := c.c.NewRequest(c.name, "TeamService.UpdateTeam", in)
	out := new(UpdateTeamResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for TeamService service

type TeamServiceHandler interface {
	GetTeamList(context.Context, *GetTeamListRequest, *GetTeamListResponse) error
	GetAllTeams(context.Context, *GetAllTeamsRequest, *GetAllTeamsResponse) error
	GetTeam(context.Context, *GetTeamRequest, *GetTeamResponse) error
	CreateTeam(context.Context, *Team, *CreateTeamResponse) error
	ToggleTeam(context.Context, *ToggleTeamRequest, *ToggleTeamResponse) error
	DeleteTeam(context.Context, *DeleteTeamRequest, *DeleteTeamResponse) error
	UpdateTeam(context.Context, *UpdateTeamRequest, *UpdateTeamResponse) error
}

func RegisterTeamServiceHandler(s server.Server, hdlr TeamServiceHandler, opts ...server.HandlerOption) error {
	type teamService interface {
		GetTeamList(ctx context.Context, in *GetTeamListRequest, out *GetTeamListResponse) error
		GetAllTeams(ctx context.Context, in *GetAllTeamsRequest, out *GetAllTeamsResponse) error
		GetTeam(ctx context.Context, in *GetTeamRequest, out *GetTeamResponse) error
		CreateTeam(ctx context.Context, in *Team, out *CreateTeamResponse) error
		ToggleTeam(ctx context.Context, in *ToggleTeamRequest, out *ToggleTeamResponse) error
		DeleteTeam(ctx context.Context, in *DeleteTeamRequest, out *DeleteTeamResponse) error
		UpdateTeam(ctx context.Context, in *UpdateTeamRequest, out *UpdateTeamResponse) error
	}
	type TeamService struct {
		teamService
	}
	h := &teamServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&TeamService{h}, opts...))
}

type teamServiceHandler struct {
	TeamServiceHandler
}

func (h *teamServiceHandler) GetTeamList(ctx context.Context, in *GetTeamListRequest, out *GetTeamListResponse) error {
	return h.TeamServiceHandler.GetTeamList(ctx, in, out)
}

func (h *teamServiceHandler) GetAllTeams(ctx context.Context, in *GetAllTeamsRequest, out *GetAllTeamsResponse) error {
	return h.TeamServiceHandler.GetAllTeams(ctx, in, out)
}

func (h *teamServiceHandler) GetTeam(ctx context.Context, in *GetTeamRequest, out *GetTeamResponse) error {
	return h.TeamServiceHandler.GetTeam(ctx, in, out)
}

func (h *teamServiceHandler) CreateTeam(ctx context.Context, in *Team, out *CreateTeamResponse) error {
	return h.TeamServiceHandler.CreateTeam(ctx, in, out)
}

func (h *teamServiceHandler) ToggleTeam(ctx context.Context, in *ToggleTeamRequest, out *ToggleTeamResponse) error {
	return h.TeamServiceHandler.ToggleTeam(ctx, in, out)
}

func (h *teamServiceHandler) DeleteTeam(ctx context.Context, in *DeleteTeamRequest, out *DeleteTeamResponse) error {
	return h.TeamServiceHandler.DeleteTeam(ctx, in, out)
}

func (h *teamServiceHandler) UpdateTeam(ctx context.Context, in *UpdateTeamRequest, out *UpdateTeamResponse) error {
	return h.TeamServiceHandler.UpdateTeam(ctx, in, out)
}
